package blackjack 

import cards.deck.CardDeck
import cards.PlayingCard
import cards.values._
import cards.suits._
import scala.io.StdIn.readLine



object Blackjack{


    def cardValue(card: PlayingCard, current_sum: Int) = card.value match {
                case NumberValue(n) => n
                case Jack => 10
                case Queen => 10
                case King => 10
                case Ace => if (current_sum + 11 <= 21) 11 else 1
            }

    def main(args: Array[String]) {
        /*
        val card1 = PlayingCard(Hearts, Queen)
        val card2 = PlayingCard(Diamonds, NumberValue(9))
        val card3 = PlayingCard(Spades, Ace)

        println(card1, cardValue(card1,0))
        println(card2, cardValue(card2,10))
        println(card3, cardValue(card3,19))
        println(card3, cardValue(card3,2))
        */
        game() 
    }


    def game() {
            
        val deck = new CardDeck
        def nextCard = {
            val card = deck.nextCard
            println(card)
            card
        }
           
        var player_current_sum: Int = 0
        var house_current_sum: Int = 0
        var player_credits: Int = 100

        while (true){
            println("PLAYER TURN. Current Credits: "+player_credits)

            var wants_card = true 
            do {
                player_current_sum += cardValue(nextCard, player_current_sum)
                println("Current sum: "+player_current_sum)
                if (player_current_sum < 21) {
                    println("Hit or Stand? [H/S]")
                    wants_card = readLine match {
                        case "H" => true
                        case "Hit" => true
                        case "h" => true
                        case "hit" => true
                        case _ => false
                        }
                    }
                } while (player_current_sum <= 21 && wants_card) 
                
            if (player_current_sum < 21) {
                println("HOUSE TURN")
                while (house_current_sum < 17) {
                    house_current_sum += cardValue(nextCard, house_current_sum)
                    println("House sum: "+house_current_sum)
                } 
                if (house_current_sum > 21) {
                    println("You win!")
                    player_credits += 1
                } else if (house_current_sum == player_current_sum) {
                    println("Tie")
                } else if (house_current_sum < player_current_sum) {
                    println("You win!")
                    player_credits += 1
                } else {
                    println("House wins!")
                    player_credits -= 1
                }
            } else if (player_current_sum == 21) {
                println("You win!")
                player_credits += 1
            } else {
                println("House wins!")
                player_credits -= 1
            }
        println()
        player_current_sum = 0
        house_current_sum = 0
       }
    }
}

