package cards

package suits {
    sealed abstract class CardSuit
    case object Spades extends CardSuit
    case object Clubs extends CardSuit
    case object Diamonds extends CardSuit
    case object Hearts extends CardSuit
}

package values {
    
    sealed abstract class CardValue

    case class NumberValue(value: Int) extends CardValue

    sealed abstract class FaceValue extends CardValue
    case object Ace extends FaceValue
    case object Jack extends FaceValue
    case object Queen extends FaceValue
    case object King extends FaceValue
}

case class PlayingCard(suit: suits.CardSuit, value: values.CardValue)
